package com.dyrk.ActiveAppsList;

import org.apache.cordova.*;
import org.json.JSONArray;
import org.json.JSONException;
import android.app.ActivityManager;
import java.io.IOException;
import android.content.Context;
import java.util.List;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class ActiveAppsList extends CordovaPlugin {
    @Override
    public boolean execute(String action, JSONArray data, final CallbackContext callbackContext) throws JSONException {

        if (action.equals("getList")) {
             cordova.getThreadPool().execute(new Runnable() {
                public void run() {
                        Process p;
                        StringBuffer output = new StringBuffer();
                        int exitStatus = 100;
                        String cmd = "ps";
                        JSONArray result =  new JSONArray();
                        try {
                                p = Runtime.getRuntime().exec(cmd);
                                BufferedReader reader = new BufferedReader( new InputStreamReader(p.getInputStream()) );
                                String line = "";
                                while ((line = reader.readLine()) != null) {
                                        output.append(line + "\n");
                                }
                                p.waitFor();
                                String[] res = output.toString().split("\n");
                                for (int i = 0; i < res.length; i++) {
                                        Matcher matcher = Pattern.compile(" ([0-9a-zA-Z^_\\-\\.]{7,30})$").matcher(res[i]);
                                        while(matcher.find()){
                                                result.put(matcher.group(1));
                                        }
                                }
                                callbackContext.success(result);
                        }
                        catch(Exception e){
                                callbackContext.error(e.getMessage());
                        }
                }

         });
          return true;
        }
       return false;
}
}
